﻿using System.ComponentModel;
using System.Runtime.CompilerServices;

namespace UWPValidationDemo.Models
{
public abstract class BindableBase : INotifyPropertyChanged
{
    public event PropertyChangedEventHandler PropertyChanged;

    public virtual void RaisePropertyChanged([CallerMemberName]string propertyName = null)
    {
        PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
    }

    protected virtual void Set<T>(ref T storage, T newValue, [CallerMemberName]string propertyName = null)
    {
        if (Equals(storage, newValue))
        {
            return;
        }
        storage = newValue;
        RaisePropertyChanged(propertyName);
    }
}
}