﻿using System.ComponentModel.DataAnnotations;

namespace UWPValidationDemo.Models
{
public class User : VerifiableBase
{
    private string _email;

    private string _password;

    private int _age;

    private string _address;

    [Required(ErrorMessage = "请填写邮箱")]
    [EmailAddress(ErrorMessage = "邮箱格式错误")]
    public string Email
    {
        get
        {
            return _email;
        }
        set
        {
            Set(ref _email, value);
        }
    }

    [Required(ErrorMessage = "请填写密码")]
    [StringLength(20, MinimumLength = 6, ErrorMessage = "密码最少 6 位，最长 20 位")]
    public string Password
    {
        get
        {
            return _password;
        }
        set
        {
            Set(ref _password, value);
        }
    }

    [Range(18, 150, ErrorMessage = "不到 18 岁不能注册，并请填写合适访问的值")]
    public int Age
    {
        get
        {
            return _age;
        }
        set
        {
            Set(ref _age, value);
        }
    }

    [StringLength(50, ErrorMessage = "地址太长")]
    public string Address
    {
        get
        {
            return _address;
        }
        set
        {
            Set(ref _address, value);
        }
    }
}
}