﻿using System.Runtime.CompilerServices;

namespace UWPValidationDemo.Models
{
public abstract class VerifiableBase : BindableBase
{
    private VerifiableObjectErrors _errors;

    public VerifiableBase()
    {
        _errors = new VerifiableObjectErrors(this);
    }

    public VerifiableObjectErrors Errors
    {
        get
        {
            return _errors;
        }
    }

    public bool IsValid
    {
        get
        {
            return _errors.Count <= 0;
        }
    }

    public override void RaisePropertyChanged([CallerMemberName] string propertyName = null)
    {
        base.RaisePropertyChanged(propertyName);
        _errors = new VerifiableObjectErrors(this);
        base.RaisePropertyChanged(nameof(Errors));
        base.RaisePropertyChanged(nameof(IsValid));
    }
}
}